import QtQuick 1.0

 Package {

     Item {
             id: listing;
             Package.name: 'list'
             //visible: wrapper.state === 'inList'
             height: listItem.height
             width: articleViewer.width

             Item {
                 width: parent.width; height: backRect.height + 3
                 id: listItem

                 Rectangle {
                     id: backRect; color: settings.backColour; opacity: index % 2 ? 0.2 : 0.4;
                     height: articleText.height + 22; width: listItem.width;
                     y: 1
                 }
                 Text {
                     id: articleText
                     anchors.verticalCenter: backRect.verticalCenter
                     x: 3
                     width: listItem.width - 6;

                     anchors.margins: 5
                     verticalAlignment: Text.AlignVCenter;
                     text: title;
                     color: (unread=="True") ? settings.mainTextColour : settings.secondaryTextColour;

                      wrapMode: Text.WordWrap; font.bold: false;
                     font.pointSize: settings.articleListingTextSize
                 }
                 MouseArea { anchors.fill: listItem;
                     onClicked: {
                         //wrapper.state = 'inArticleDisplay';
                         articleView.positionViewAtIndex(index, ListView.Contain);
                         articleView.visible = true;
                     }
                 }
             }

     }

     Item {
         id: viewer
         Package.name: 'article'
         //visible: wrapper.state === 'inArticleDisplay'
         height: articleViewer.height
         width: articleViewer.width

         Item {
             id: flipItem;
             width: parent.width; height: parent.height;

             //property string url: (articleView.visible && Math.abs(articleView.currentIndex-index)<2) ? path: "";
             property string html: controller.getArticle(articleViewer.feedid, articleid)
             ArticleDisplay {
                 zoomEnabled: articleViewer.zoomEnabled;
                 property bool vertPanningEnabled: articleViewer.vertPanningEnabled;

                 states: [ State {
                         name: 'articleIsRead';
                     when: articleView.visible && articleView.currentIndex === index;
                     StateChangeScript {
                         name: "myScript"
                         script: {
                             //flipItem.url=path;
                             controller.setEntryRead(articleViewer.feedid, articleid)
                         }
                     }
                     }
                 ]
             }
         }
     }

//         state: 'inList'
//         states: [
//             State {
//                 name: 'inList'
//                 ParentChange { target: wrapper; parent: listDelegate }
//             },
//             State {
//                 name: 'inArticleDisplay'
//                 ParentChange {
//                     target: wrapper; parent: articleDelegate
//                     //x: 0; y: 0; width: gridDelegate.width; height: gridDelegate.height
//                 }
//             }
//         ]

//         transitions: [
//             Transition {
//                 ParentAnimation {
//                     NumberAnimation { properties: 'x,y,width,height'; duration: 300 }
//                 }
//             }
//         ]
//     }
 }
